DECLARE SUB parameters (xmean#, vx#, tm#)
DECLARE FUNCTION F95# (n2%, n1%)
DECLARE FUNCTION KeyChoice$ (compare$)
DECLARE FUNCTION t95# (n1%)
DECLARE FUNCTION Xc# (time#, xmean#, vx#, ym#())
DECLARE FUNCTION Yc# (xh#, vx#, xmean#)
DECLARE SUB DestData (temperature#(), times#(), property#(), ntimes%(), nProperty%())
DECLARE SUB DestGraph (temperature#, z#(), nt%, pMean#(), p#(), np%(), pmax#, z1#, z2#)
DECLARE SUB DestLinTest (z#(), pMean#(), pVar#(), np%(), start%, included%, nd%, pa#, pb#, F1#, Ex#)
DECLARE SUB DestMeans (p#(), nt%, np%(), pMean#(), pVar#(), pmax#)
DECLARE SUB DestTransform (temperature#(), time#(), property#(), ntimes%(), nProperty%())
DECLARE SUB Graph (ym#(), xmean#, vx#)
DECLARE SUB GraphScreenMode ()
DECLARE SUB MeanVar (ym#(), s1#(), epsilon#)
DECLARE SUB NonDestData (temperature#(), time#())
DECLARE SUB parameters (xmean#, vx#, tm#)
DECLARE SUB Regression (xmean#, vx#, ym#(), s1#(), epsilon#, tm#, tl#)
DECLARE SUB Report (test$, temperature#(), time#(), ntimes%(), tm#, tl#)
DEFINT I-N
DEFDBL A-H, O-Z

TYPE statistic
    value AS DOUBLE
    nn AS INTEGER
    nd AS INTEGER
    reflevel AS DOUBLE
END TYPE

TYPE selection
    start AS INTEGER
    included AS INTEGER
    F AS DOUBLE
    nn AS INTEGER
    nd AS INTEGER
    F995 AS DOUBLE
    extrapolation AS DOUBLE
END TYPE

'$DYNAMIC

DIM SHARED k, l, x(1), y(1, 1), nt, n(1), m(1), mt, flag(9) AS INTEGER
DIM SHARED TI, TC, HIC, ymean, a, b, s, DestSel(1) AS selection, chi AS statistic
DIM SHARED wd AS INTEGER, ht AS INTEGER, scrn AS INTEGER, lines
DIM SHARED p0, filename AS STRING
DIM temperature(1), time(1, 1), nProperty(1, 1)
DIM property(1, 1, 1), ntimes(1)
DIM SHARED F AS statistic
DIM ym(1), s1(1)

CONST T0 = 273.15#, TITime = 20000#, FALSE = 0, TRUE = NOT FALSE

GraphScreenMode

CLS
INPUT "Enter the drive letter for your data ", drive$
drive$ = LEFT$(drive$, 1) + ":"
INPUT "Enter the directory name ", directory$
IF directory$ = "" THEN directory$ = "."
INPUT "Enter the file name ", filename
filename = drive$ + "\" + directory$ + "\" + filename

PRINT "Is this a destructive test data set? Y/N"
test$ = KeyChoice$("YN")
IF test$ = "Y" THEN
    test$ = "DEST"
    DestData temperature(), time(), property(), ntimes(), nProperty()
    REDIM DestSel(k) AS selection
    DestTransform temperature(), time(), property(), ntimes(), nProperty()
ELSE
    test$ = "ND"
    NonDestData temperature(), time()
END IF

MeanVar ym(), s1(), epsilon
Regression xmean, vx, ym(), s1(), epsilon, tm, tl

DO
    Report test$, temperature(), time(), ntimes(), tm, tl
    any$ = INPUT$(1)
    IF any$ = CHR$(27) THEN EXIT DO
    Graph ym(), xmean, vx
    any$ = INPUT$(1)
    SCREEN 0
LOOP UNTIL any$ = CHR$(27)
parameters xmean, vx, tm

END

ChangeGraphMode:
    SELECT CASE scrn
        CASE 11
            scrn = 9
            RESUME
        CASE 9
            scrn = 8
            RESUME
        CASE 8
            scrn = 3
            RESUME
        CASE 3
            CLS
            PRINT "No suitable graphics adapter/driver installed."
            PRINT "You must have a graphics card, EGA, VGA or HERCULES"
            PRINT "If you have a HERCULES card, you must run MSHERC before this program"
            any$ = INPUT$(1)
    END SELECT

REM $STATIC
SUB DestData (temperature(), times(), property(), ntimes(), nProperty())

    OPEN filename FOR INPUT AS #1
    INPUT #1, k
    INPUT #1, l
    INPUT #1, maxnp
    REDIM temperature(k), x(k), times(k, l), property(k, l, maxnp)
    REDIM ntimes(k), nProperty(k, l), y(k, l * maxnp), n(k), m(k)
    REDIM DestSel(k) AS selection
    FOR i = 1 TO k
        INPUT #1, temperature(i)
        x(i) = 1 / (temperature(i) + T0)
        INPUT #1, ntimes(i)
        FOR j = 1 TO ntimes(i)
            INPUT #1, times(i, j)
            INPUT #1, nProperty(i, j)
            FOR j1 = 1 TO nProperty(i, j)
                INPUT #1, property(i, j, j1)
            NEXT j1
        NEXT j
    NEXT i

    INPUT #1, p0

    CLOSE #1

END SUB

SUB DestGraph (temperature, z(), ntms, pMean(), p(), np(), pmax, z1, z2)

    CLS 0
    z1 = z(1) * .98
    z2 = z(ntms) * 1.05
    r1 = (z2 - z1) / 500
    r2 = 3 * r1
    p2 = 1.1 * pmax
    SCREEN scrn
    VIEW (wd / 20, ht / 100)-(wd * .95, ht * .75), 0, 7
    WINDOW (z1, 0)-(z2, p2)
    FOR i = 1 TO ntms
        CIRCLE (z(i), pMean(i)), r2, 7
        FOR j = 1 TO np(i)
            CIRCLE (z(i), p(i, j)), r1, 7
        NEXT j
    NEXT i
    LINE (z1, p0)-(z2, p0), 7
    VIEW PRINT lines * .8 TO lines
    LOCATE lines * .8, 1, 0
    PRINT "Temperature "; temperature;
    VIEW PRINT 1 + lines * .8 TO lines

END SUB

SUB DestLinTest (z(), pMean(), pVar(), np(), start%, included, nd, pa, pb, F1, Ex)

    DIM g AS INTEGER, leastp AS DOUBLE
    leastp = pMean(start%)
    highp = pMean(start%)
    nd = 0
    FOR g1% = 1 TO included
        g = start% - 1 + g1%
        ss1 = ss1 + pVar(g) * (np(g) - 1)
        nd = nd + np(g)
        sz = sz + np(g) * z(g)
        ssz = ssz + np(g) * z(g) * z(g)
        ssmp = ssmp + np(g) * pMean(g) * pMean(g)
        smpz = smpz + np(g) * pMean(g) * z(g)
        sp = sp + np(g) * pMean(g)
        IF pMean(g) < leastp THEN leastp = pMean(g)
        IF pMean(g) > highp THEN highp = pMean(g)
    NEXT g1%
    nn = included - 2
    sa = smpz - sz * sp / nd
    sb = ssz - sz * sz / nd
    sc = ssmp - sp * sp / nd
    ss2 = sc * (1 - sa ^ 2 / (sb * sc)) / nn
    pb = sa / sb
    pa = (sp - pb * sz) / nd
    nd = nd - included
    ss1 = ss1 / nd
    F1 = ss2 / ss1
    Ex = (leastp - p0) / (highp - leastp)

END SUB

SUB DestMeans (p(), nt, np(), pMean(), pVar(), pmax)
    
    'This subroutine carries out Equations 3 & 4. pVar is (s1g)^2.
    DIM g AS INTEGER, h AS INTEGER
    pmax = 0
    FOR g = 1 TO nt
        pMean(g) = 0
        pVar(g) = 0
        FOR h = 1 TO np(g)
            pVar(g) = pVar(g) + p(g, h) * p(g, h)
            pMean(g) = pMean(g) + p(g, h)
            IF p(g, h) > pmax THEN pmax = p(g, h)
        NEXT h
        pMean(g) = pMean(g) / np(g)
        pVar(g) = (pVar(g) - np(g) * pMean(g) ^ 2) / (np(g) - 1)
    NEXT g

END SUB

SUB DestTransform (temperature(), time(), property(), ntimes(), nProperty())

    maxnp = UBOUND(property, 3)
    FOR i = 1 TO k      'Copy into arrays without the i dimension
        ntms = ntimes(i)
        REDIM z(ntms), p(ntms, maxnp), np(ntms), pMean(ntms), pVar(ntms)
        FOR j = 1 TO ntms
            np(j) = nProperty(i, j)
            z(j) = LOG(time(i, j))
            FOR j1 = 1 TO np(j)
                p(j, j1) = property(i, j, j1)
            NEXT j1
        NEXT j

        FOR j = 1 TO ntms   'Sort z values into increasing order
            j1 = j
            FOR j2 = j1 + 1 TO ntms
                IF z(j2) < z(j1) THEN j1 = j2
            NEXT j2
            IF j1 > j THEN
                SWAP z(j), z(j1)
                SWAP np(j), np(j1)
                FOR j2 = 1 TO maxnp     'Taking p values with them
                    SWAP p(j, j2), p(j1, j2)
                NEXT j2
            END IF
        NEXT j
        ThisTemperature = temperature(i)
        DestMeans p(), ntms, np(), pMean(), pVar(), pmax
        DestGraph ThisTemperature, z(), ntms, pMean(), p(), np(), pmax, z1, z2
        DO
            CLS 2
            INPUT "Enter the first property set for selection ", start%
            INPUT "How many groups to be included?            ", included
            DestLinTest z(), pMean(), pVar(), np(), start%, included, nd, pa, pb, F1, Ex
            LINE (z1, pa + pb * z1)-(z2, pa + pb * z2)
            PRINT USING "Enter the Table value of F995_,###_,#### "; included - 2; nd;
            INPUT "    ", F995
            IF Ex > 0 THEN
            PRINT USING "Extrapolation = #.####_, F = ##.###: F95_,##_,### = ###.####: accept Y/N?"; Ex; F1; included - 2; nd; F95(nd, included - 2);
            ELSE
            PRINT USING "F = ##.###: F95_,##_,### = ###.####: accept Y/N?"; F1; included - 2; nd; F95(nd, included - 2);
            END IF
            ans$ = KeyChoice$("YN")
            IF ans$ = "N" THEN LINE (z1, pa + pb * z1)-(z2, pa + pb * z2), 0
        LOOP UNTIL ans$ = "Y"
        FOR g1% = 1 TO included
            g% = start% - 1 + g1%
            FOR h% = 1 TO np(g%)
                n(i) = n(i) + 1
                y(i, n(i)) = z(g%) - (p(g%, h%) - p0) / pb
            NEXT h%
        NEXT g1%
        DestSel(i).start = start%
        DestSel(i).included = included
        DestSel(i).F = F1
        DestSel(i).nn = included - 2
        DestSel(i).nd = n(i) - included
        DestSel(i).F995 = F995
        DestSel(i).extrapolation = Ex
        m(i) = n(i)
        IF Ex > 0 THEN flag(6) = TRUE
        IF F1 > F95(nd, included - 2) THEN flag(7) = TRUE
        IF F1 > F995 THEN flag(8) = TRUE
    NEXT i
    SCREEN 0
    VIEW PRINT
    CLS

END SUB

FUNCTION F95 (n2, n1)
    F95 = 1.8718 + 1.9993 / n1 + 10.468 / n2
END FUNCTION

REM $DYNAMIC
SUB Graph (ym(), xmean, vx)

        SCREEN scrn

        IF TI > 180 THEN interval = 20 ELSE interval = 10

        x1 = 1 / (TI - 20 + T0)
        x2 = x1 - .0008
        y1 = LOG(10)
        y2 = 5 * LOG(10)
        xrange = x1 - x2
        yrange = y2 - y1

        xstart% = 10 * ((TI - 10) \ 10)
        xend% = 10 * ((1 / x2 - T0) \ 10)
        ystart% = 2
        yend% = 4

        LOCATE 1, 1, 0
        CLS
        VIEW (wd / 100, ht * .045)-(wd * .99, ht * .99), 0, 7
        WINDOW (x2, y1)-(x1, y2)
        FOR temp = xstart% TO xend% STEP interval
            xe = x1 + x2 - 1 / (temp + T0)
            IF temp MOD 50 = 0 AND xe - x2 > xrange / 40 THEN
                LOCATE lines - 1, (xe - x2) / xrange * 80 - 1
                IF x1 - xe > xrange / 20 THEN PRINT temp;
            END IF
            IF temp MOD 50 = 0 THEN z = yrange / 25 ELSE z = yrange / 50
            LINE (xe, y2 - z)-(xe, y2)
            LINE (xe, y1)-(xe, y1 + z)
        NEXT temp

        FOR ys% = 2 TO 4
            LINE (x2, ys% * LOG(10))-(x2 + xrange / 50, ys% * LOG(10))
            LINE (x1, ys% * LOG(10))-(x1 - xrange / 50, ys% * LOG(10))
            LOCATE lines - (ys% - 1) * lines \ 4, 3
            PRINT 10 ^ ys%;
        NEXT ys%

        LINE (x2, a + b * x1)-(x1, a + b * x2)
        inc# = xrange / 50
        FOR i = 0 TO 49
            xe = x2 + i * inc#
            LINE (x1 + x2 - xe, Yc(xe, vx, xmean))-(x1 + x2 - (xe + inc#), Yc(xe + inc#, vx, xmean)), , , &HF00F
        NEXT i

        FOR i = 1 TO k
            CIRCLE (x1 + x2 - x(i), ym(i)), xrange / 250
        NEXT i

        LOCATE 5, 40
        PRINT "Regression                         "
        LOCATE 7, 40
        PRINT "95% Confidence";
        LINE (x2 + xrange * .75, (5 - 14 / lines) * LOG(10))-(x2 + xrange * .85, (5 - 14 / lines) * LOG(10))
        LINE (x2 + xrange * .75, (5 - 22 / lines) * LOG(10))-(x2 + xrange * .85, (5 - 22 / lines) * LOG(10)), , , &HF00F
        LOCATE 5, 40

        FOR i = 1 TO k
            FOR j = 1 TO n(i)
                CIRCLE (x1 + x2 - x(i), y(i, j)), xrange / 640
            NEXT j
        NEXT i
        VIEW PRINT 1 TO 1
        CLS 2
        PRINT "Press ESC to finish";
        ON ERROR GOTO 0

END SUB

REM $STATIC
SUB GraphScreenMode

    ON ERROR GOTO ChangeGraphMode

    scrn = 11
    SCREEN scrn, , 0, 0
    SELECT CASE scrn
        CASE 11
            wd = 639
            ht = 479
            lines = 30
        CASE 9
            wd = 639
            ht = 349
            lines = 25
        CASE 8
            wd = 639
            ht = 199
            lines = 25
        CASE 3
            wd = 719
            ht = 347
            lines = 25
    END SELECT

    SCREEN 0
    ON ERROR GOTO 0

END SUB

FUNCTION KeyChoice$ (compare$)

    DIM p AS INTEGER
    compare$ = UCASE$(compare$)
    DO WHILE p = 0
        p = INSTR(compare$, UCASE$(INPUT$(1)))
    LOOP
    KeyChoice$ = MID$(compare$, p, 1)

END FUNCTION

SUB MeanVar (ym(), s1(), epsilon)

    DIM mu AS DOUBLE

    REDIM s1(k), ym(k)
    FOR i = 1 TO k
        IF n(i) = m(i) THEN
            FOR j = 1 TO n(i)
                ym(i) = ym(i) + y(i, j)
                s1(i) = s1(i) + y(i, j) * y(i, j)
            NEXT j
            ym(i) = ym(i) / n(i)
            s1(i) = (s1(i) - n(i) * ym(i) ^ 2) / (n(i) - 1)
            varfactor = varfactor + 1
        ELSE
            PRINT USING "For the values ### and ### of m and n:"; m(i); n(i)
            INPUT "Enter the value of alpha ", alpha
            INPUT "Enter the value of beta  ", beta
            INPUT "Enter the value of mu    ", mu
            INPUT "Enter the value of epsilon ", epsilon
            sy = 0
            ssy = 0
            FOR j = 1 TO n(i)   'Sort y values into increasing order
                j1 = j
                FOR j2 = j1 + 1 TO n(i)
                    IF y(i, j2) < y(i, j1) THEN j1 = j2
                NEXT j2
                IF j1 > j THEN SWAP y(i, j), y(i, j1)
            NEXT j
            FOR j = 1 TO n(i) - 1   'Calculate mean and variance of y values
                sy = sy + y(i, j)
                ssy = ssy + (y(i, n(i)) - y(i, j)) ^ 2
            NEXT j
            ym(i) = mu * sy / (n(i) - 1) + (1 - mu) * y(i, n(i))
            s1(i) = alpha * ssy + beta * ((n(i) - 1) * y(i, n(i)) - sy) ^ 2
            varfactor = varfactor + epsilon
        END IF
    nt = nt + n(i)
    mt = mt + m(i)
    NEXT i
    epsilon = varfactor / k     'Varfactor is a temporary variable for the
                                'pooled epsilon
END SUB

SUB NonDestData (temperature(), time())

    OPEN filename FOR INPUT AS #1
    INPUT #1, k
    INPUT #1, l
    REDIM temperature(k), time(k, l), x(k), y(k, l), n(k), m(k)
    FOR i = 1 TO k
        INPUT #1, temperature(i)
        x(i) = 1 / (temperature(i) + T0)
        INPUT #1, m(i)
        INPUT #1, n(i)
        FOR j = 1 TO n(i)
            INPUT #1, time(i, j)
            y(i, j) = LOG(time(i, j))
        NEXT j
    NEXT i
    CLOSE #1

END SUB

SUB parameters (xmean, vx, tm)

    DIM filenum AS INTEGER, filename2 AS STRING
    DIM l1 AS INTEGER

    l1 = INSTR(filename, ".")
    filename2 = LEFT$(filename, l1 - 1) + ".int"

    filenum = FREEFILE
    OPEN filename2 FOR OUTPUT AS #filenum
    PRINT #filenum, xmean
    PRINT #filenum, vx
    PRINT #filenum, ymean
    PRINT #filenum, s
    PRINT #filenum, nt
    PRINT #filenum, b
    PRINT #filenum, a
    PRINT #filenum, tm
    CLOSE #filenum
    PRINT
    PRINT "The data values needed for RTE calculation have been saved in:"
    PRINT filename2
    PRINT "Press any key to finish"
    any$ = INPUT$(1)

END SUB

SUB Regression (xmean, vx, ym(), s1(), epsilon, tm, tl)

'   The following are input parameters: ym(), s1()
'   n() is shared input
'   xmean, vx, are output
'   flag(), TI, TC, HIC, chi, F are shared output
'   tm is longest mean time to endpoint: tl is lowet test temperature

    FOR i = 1 TO k

        sy = sy + ym(i) * n(i)
        sx = sx + n(i) * x(i)
        ssx = ssx + n(i) * x(i) * x(i)
        spxy = spxy + n(i) * x(i) * ym(i)
        ssmy = ssmy + ym(i) * ym(i) * n(i)

        ss1 = ss1 + s1(i) * (n(i) - 1)

        g = g + 1 / (n(i) - 1)
        h = h + (n(i) - 1) * LOG(s1(i))

    NEXT i

    ss1 = ss1 / (nt - k)

    chi.value = ((nt - k) * LOG(ss1) - h) / (1 + (g - 1 / (nt - k)) / 3 / (k - 1))
    chi.nd = k - 1
    chi.nn = 0
    chi.reflevel = 0

    sa = spxy - sx * sy / nt
    sb = ssx - sx * sx / nt
    sc = ssmy - sy * sy / nt

    r0 = sa ^ 2 / (sb * sc)     'Square of correlation coefficient
    ss1 = ss1 * epsilon
    ss2 = sc * (1 - r0) / (k - 2)
    F.value = ss2 / ss1
    F.nd = nt - k
    F.nn = k - 2

    ymean = sy / nt
    xmean = sx / nt

    b = sa / sb
    a = ymean - b * xmean

    F.reflevel = F95(F.nd, F.nn)
    IF F.value > F.reflevel THEN
        flag(3) = TRUE
        F1 = F.value / F.reflevel
    ELSE
        flag(3) = FALSE
        F1 = 1
    END IF

    vx = sb / nt
    s = (ss1 * F.nd * F1 + ss2 * F.nn) / (nt - 2)

    TI = b / (LOG(TITime) - a) - T0
    TC = 1 / Xc(TITime, xmean, vx, ym()) - T0
    HIC = b / (LOG(TITime / 2) - a) - b / (LOG(TITime) - a)

    xmax = 0
    FOR i = 1 TO k
        IF x(i) > xmax THEN
            xmax = x(i)
            lowest = i
        END IF
    NEXT i

    tl = 1 / x(lowest) - T0
    TempExtrapolation = tl - TI
    tm = EXP(ym(lowest))
    dispersion = (TI - TC) / HIC

    IF TempExtrapolation > 25 THEN flag(1) = TRUE ELSE flag(1) = FALSE
    IF tm < TITime / 4 THEN flag(2) = TRUE ELSE flag(2) = FALSE

    SELECT CASE dispersion
    CASE .6 TO 1.6
        flag(4) = TRUE
        flag(5) = FALSE
    CASE IS > 1.6
        flag(4) = FALSE
        flag(5) = TRUE
    CASE ELSE
        flag(4) = FALSE
        flag(5) = FALSE
    END SELECT


END SUB

SUB Report (test$, temperature(), time(), ntimes(), tm, tl)
    CLS
    IF flag(1) OR flag(2) OR (flag(4) AND (flag(3) OR flag(6) OR flag(7))) THEN flag(9) = TRUE
    IF flag(9) OR flag(5) OR (flag(6) AND flag(7)) THEN flag(9) = TRUE
    IF flag(8) OR flag(9) THEN flag(9) = TRUE
    IF flag(4) AND NOT (flag(3) OR flag(6) OR flag(7)) THEN
        TIa = TC + .6 * HIC
    ELSE
        TIa = TI
    END IF
    IF flag(9) THEN
        form$ = "TIg = ###.#_, HICg = ###.#"
    ELSE
        form$ = "TI (HIC): ###.# (###.#)"
    END IF
    PRINT USING "The result is " + form$; TIa; HIC
    PRINT
    PRINT USING "Lower 95% confidence limit of TI ###.#"; TC
    PRINT USING "Chi-Squared (DF) ###.#### (####)"; chi.value; chi.nd
    PRINT USING "F (nn, nd) ###.### (##_,####)"; F.value; F.nn; F.nd
    PRINT USING "Lowest ageing temperature ###: longest mean time to endpoint #######"; tl; tm
    IF flag(4) AND NOT (flag(3) OR flag(6) OR flag(7)) THEN
        PRINT USING "High dispersion: TI adjusted from ###.# to ###.#"; TI; TIa
    END IF
    IF flag(5) THEN PRINT "Excessive data dispersion"
    IF flag(3) THEN PRINT "Non-significant departure from linearity"
    IF flag(6) AND (flag(4) OR flag(5)) THEN PRINT
    PRINT
    IF test$ = "DEST" THEN
        PRINT "Selected ageing times"
        FOR i = 1 TO k
            PRINT "Temperature "; temperature(i),
            FOR j = 1 TO DestSel(i).included
                PRINT time(i, DestSel(i).start - 1 + j);
            NEXT j
            PRINT
        NEXT i
        PRINT
        PRINT "Linearity tests"
        FOR i = 1 TO k
            PRINT USING "Temperature ####_, F (nn_,nd) ###.### (##_,####)"; temperature(i); DestSel(i).F; DestSel(i).nn; DestSel(i).nd;
            IF DestSel(i).extrapolation > 0 THEN
                PRINT USING "    Extrapolation  #.####"; DestSel(i).extrapolation
            ELSE
                PRINT
            END IF
        NEXT i
    END IF


END SUB

FUNCTION t95 (n1)
    t95 = 1.6282 + .0001688 * n1 + 1.8481 / n1
END FUNCTION

FUNCTION Xc (time, xmean, vx, ym())

    tcen = 1 / (1 / t95(nt - 2) - (1 - nt / mt) / (nt / 8 + 4.5))
    br = b - tcen ^ 2 * s / b / vx / nt
    sr = SQR(s * (br / b + ((LOG(time) - a) / b - xmean) ^ 2 / vx) / nt)
    Xc = xmean + (LOG(time) - ymean) / br + tcen * sr / br

END FUNCTION

FUNCTION Yc (xh, vx, xmean)

    tcen = 1 / (1 / t95(nt - 2) - (1 - nt / mt) / (nt / 8 + 4.5))
    yb = a + b * xh
    ci = tcen * SQR(s * (1 + (xh - xmean) ^ 2 / vx) / nt)
    Yc = yb - ci


END FUNCTION

