DECLARE FUNCTION t95# (n1%)
DECLARE SUB CalcTemps (c AS ANY, tim AS DOUBLE, TI AS DOUBLE, TC AS DOUBLE)
DECLARE SUB ReadData (c AS ANY, datatype AS STRING)

CONST T0 = 273.15

TYPE DataSet
    xmean AS DOUBLE
    vx  AS DOUBLE
    ymean  AS DOUBLE
    s  AS DOUBLE
    nt AS INTEGER
    b AS DOUBLE
    a AS DOUBLE
    tmax AS DOUBLE
    TI AS DOUBLE
    TC AS DOUBLE
    HIC AS DOUBLE
END TYPE

DIM Control AS DataSet, Candidate AS DataSet, CorrTime AS DOUBLE
DIM RTC AS DOUBLE, AgeingTime AS DOUBLE

oldline1:
CLS
ON ERROR GOTO erh1
ReadData Control, "Control"

oldline2:
ON ERROR GOTO erh2
ReadData Candidate, "Candidate"
ON ERROR GOTO 0

CorrTime = EXP(Control.a + Control.b / (Control.TI + T0))

CalcTemps Control, CorrTime, TI#, TC#
Control.TC = TC#
CalcTemps Control, CorrTime / 2, TI#, TC#
Control.HIC = TI# - Control.TI

CalcTemps Candidate, CorrTime, TI#, TC#
Candidate.TI = TI#
Candidate.TC = TC#
CalcTemps Candidate, CorrTime / 2, TI#, TC#
Candidate.HIC = TI# - Candidate.TI

RTC = SQR((Control.TI - Control.TC) ^ 2 + (Candidate.TI - Candidate.TC) ^ 2)

IF Candidate.tmax < Control.tmax THEN
    AgeingTime = Control.tmax
ELSE
    AgeingTime = Candidate.tmax
END IF


PRINT
PRINT USING "RTE = ###.##"; Candidate.TI
PRINT USING "Conf.Interval = ##.##"; RTC
PRINT USING "(Control: ##.##  Candidate: ##.##)"; Control.TI - Control.TC; Candidate.TI - Candidate.TC
PRINT
PRINT USING "Halving Interval = ##.##"; Candidate.HIC
PRINT
PRINT USING "Correlation Time = ###### h."; CorrTime

PRINT
PRINT USING "Extrapolation factor ##.#"; CorrTime / AgeingTime

PRINT "Press any key to finish"
any$ = INPUT$(1)

END

erh1:
    PRINT "File not found: press any key to resume"
    any$ = INPUT$(1)
    RESUME oldline1
erh2:
    PRINT "File not found: press any key to resume"
    any$ = INPUT$(1)
    RESUME oldline2

SUB CalcTemps (c AS DataSet, tim AS DOUBLE, TI AS DOUBLE, TC AS DOUBLE)

    DIM t AS DOUBLE, br AS DOUBLE, sr AS DOUBLE, xc AS DOUBLE

    TI = c.b / (LOG(tim) - c.a) - T0


    t = t95(c.nt - 2)
    br = c.b - t ^ 2 * c.s / c.nt / c.b / c.vx
    sr = SQR(c.s / c.nt * (br / c.b * ((LOG(tim) - c.a) / c.b - c.xmean) ^ 2 / c.vx))
    xc = c.xmean + (LOG(tim) - c.ymean) / br + t * sr / br
    TC = 1 / xc - T0

END SUB

SUB ReadData (c AS DataSet, datatype AS STRING)
                                               
oldline:
   
    DIM filename  AS STRING, filenum AS INTEGER
    filenum = FREEFILE

    PRINT "Enter the drive letter for your " + datatype + " data ";
    INPUT "", drive$
    drive$ = LEFT$(drive$, 1) + ":"
    INPUT "Enter the directory name ", directory$
    IF directory$ = "" THEN directory$ = "."
    INPUT "Enter the file name (no file ending) ", filename
    filename = drive$ + "\" + directory$ + "\" + filename + ".int"
    
    PRINT

    OPEN filename FOR INPUT AS #filenum
        INPUT #filenum, c.xmean
        INPUT #filenum, c.vx
        INPUT #filenum, c.ymean
        INPUT #filenum, c.s
        INPUT #filenum, c.nt
        INPUT #filenum, c.b
        INPUT #filenum, c.a
        INPUT #filenum, c.tmax
    CLOSE #filenum

    IF datatype = "Control" THEN
        PRINT "Enter the value of ATE for the control material ";
        INPUT "", c.TI
        PRINT
    END IF


END SUB

FUNCTION t95# (n1 AS INTEGER)

    t95 = 1.6282 + .0001688 * n1 + 1.8481 / n1

END FUNCTION

